using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using System.Transactions;
using System.Data.SqlClient;
using System.Threading;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_EstructurasPartesPeticionDatos_Arbol_Datos
    {
        #region MODELOS

        #region Modelo Simple
        private MYT_EstructurasPartesPeticionDatos_Arbol g_mdl_MYT_EstructurasPartesPeticionDatos_Arbol = null;
        public MYT_EstructurasPartesPeticionDatos_Arbol Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " + nameof(MYT_EstructurasPartesPeticionDatos_Arbol) + "." + nameof(MYT_EstructurasPartesPeticionDatos_Arbol.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Arbol_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MYT_EstructurasPartesPeticionDatos_Arbol;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MYT_EstructurasPartesPeticionDatos_Arbol = obj_Exferia_Entities.Database.SqlQuery<MYT_EstructurasPartesPeticionDatos_Arbol>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Arbol_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<MYT_EstructurasPartesPeticionDatos_Arbol> g_lst_MYT_EstructurasPartesPeticionDatos_Arbol = null;

        public List<MYT_EstructurasPartesPeticionDatos_Arbol> Obtener_ModeloListado_Por_IdEstructuraPartesPeticionDatosCabecera(long _lng_idEstructuraPartePeticionDatoCabecera)
        {
            try
            {
                g_lst_MYT_EstructurasPartesPeticionDatos_Arbol = null;


                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEstructuraPartePeticionDatoCabecera",  _lng_idEstructuraPartePeticionDatoCabecera)
                };

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                             " WHERE " + nameof(MYT_EstructurasPartesPeticionDatos_Arbol) + "." + nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoCabecera) + "=@idEstructuraPartePeticionDatoCabecera ";


                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);


                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Arbol_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdEstructuraPartesPeticionDatosCabecera), true);
            }

            return g_lst_MYT_EstructurasPartesPeticionDatos_Arbol;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(  string _str_SQL,
                                                        object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_MYT_EstructurasPartesPeticionDatos_Arbol = obj_Exferia_Entities.Database.SqlQuery<MYT_EstructurasPartesPeticionDatos_Arbol>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Arbol_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion
        #endregion


        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.id) + " , " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoCabecera) + " , " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoArbol_Padre) + " , " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoSeccion) + " , " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoPregunta) + " , " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoRespuesta) + " , " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.finPeticionDatos) + " , " +
                    nameof(MYT_EstructurasPartesPeticionDatos_Arbol.orden) +
               " FROM " + nameof(MYT_EstructurasPartesPeticionDatos_Arbol);
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Insertar(MYT_EstructurasPartesPeticionDatos_Arbol _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_EstructurasPartesPeticionDatos_Arbol mdl_MYT_EstructurasPartesPeticionDatos_Arbol_DatosViejos = new MYT_EstructurasPartesPeticionDatos_Arbol();
                MYT_EstructurasPartesPeticionDatos_Arbol mdl_MYT_EstructurasPartesPeticionDatos_Arbol_Final = new MYT_EstructurasPartesPeticionDatos_Arbol();

                //Tipo de Accion que se va a realizar
                mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                // Cargar los Datos del Modelo
                Funciones.CopiarPropiedadesObjetos(_mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR, mdl_MYT_EstructurasPartesPeticionDatos_Arbol_Final, false, false);

                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(MYT_EstructurasPartesPeticionDatos_Arbol) +
                                            " (" +
                                                nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoCabecera) + "," +
                                                nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoArbol_Padre) + "," +
                                                nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoSeccion) + "," +
                                                nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoPregunta) + "," +
                                                nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoRespuesta) + "," +
                                                nameof(MYT_EstructurasPartesPeticionDatos_Arbol.finPeticionDatos) + "," +
                                                nameof(MYT_EstructurasPartesPeticionDatos_Arbol.orden) + 
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(MYT_EstructurasPartesPeticionDatos_Arbol.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@idEstructuraPartePeticionDatoCabecera," +
                                                "@idEstructuraPartePeticionDatoArbol_Padre," +
                                                "@idEstructuraPartePeticionDatoSeccion," +
                                                "@idEstructuraPartePeticionDatoPregunta," +
                                                "@idEstructuraPartePeticionDatoRespuesta," +
                                                "@finPeticionDatos," +
                                                "@orden" +
                                            " ) ";

                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@idEstructuraPartePeticionDatoCabecera",  _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoCabecera),
                    _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoArbol_Padre!=null
                        ?   new SqlParameter("@idEstructuraPartePeticionDatoArbol_Padre", _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoArbol_Padre.Value)
                        :   new SqlParameter("@idEstructuraPartePeticionDatoArbol_Padre",  DBNull.Value),
                    _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoSeccion!=null
                        ?   new SqlParameter("@idEstructuraPartePeticionDatoSeccion", _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoSeccion.Value)
                        :   new SqlParameter("@idEstructuraPartePeticionDatoSeccion",  DBNull.Value),
                    _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoPregunta!=null
                        ?   new SqlParameter("@idEstructuraPartePeticionDatoPregunta", _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoPregunta.Value)
                        :   new SqlParameter("@idEstructuraPartePeticionDatoPregunta",  DBNull.Value),
                    _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoRespuesta!=null
                        ?   new SqlParameter("@idEstructuraPartePeticionDatoRespuesta", _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.idEstructuraPartePeticionDatoRespuesta.Value)
                        :   new SqlParameter("@idEstructuraPartePeticionDatoRespuesta",  DBNull.Value),
                    _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.finPeticionDatos!=null
                        ?   new SqlParameter("@finPeticionDatos", _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.finPeticionDatos.Value)
                        :   new SqlParameter("@finPeticionDatos",  DBNull.Value),
                    new SqlParameter("@orden",  _mdl_MYT_EstructurasPartesPeticionDatos_Arbol_AGRABAR.orden)

                };
                #endregion

                //Id de la tabla
                mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                

                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Arbol_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public INTERNO_ValorDevuelto_Modelo Borrar_Por_CabeceraSeccion(long _lng_idEstructuraPartePeticionDatoCabecera,long _lng_idEstructuraPartePeticionDatoSeccion)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Borrar
                string str_SQL_Borrar = " DELETE FROM " + nameof(MYT_EstructurasPartesPeticionDatos_Arbol) +
                                        " WHERE " +
                                            nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoCabecera) + "=@idEstructuraPartePeticionDatoCabecera and " +
                                            nameof(MYT_EstructurasPartesPeticionDatos_Arbol.idEstructuraPartePeticionDatoSeccion) + "=@idEstructuraPartePeticionDatoSeccion";

                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@idEstructuraPartePeticionDatoCabecera", _lng_idEstructuraPartePeticionDatoCabecera),
                    new SqlParameter("@idEstructuraPartePeticionDatoSeccion", _lng_idEstructuraPartePeticionDatoSeccion)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Borrar, arr_Parametros_Delete);

                   
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_EstructurasPartesPeticionDatos_Arbol_Datos) + "/" + nameof(Borrar_Por_CabeceraSeccion), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
